' SCROLL MENU shows how to have a 'scrolling' menu using QBasic.
' SCROLL MENU is supplied free of charge and AS IS. The author
' can not be held responsible for its uses. Please feel free
' to change and/or use the code it any way you like. Replies
' are welcome at CIS 73362,2377.

  DEFINT A-Z

' declare subs
  DECLARE SUB ScrollMenu (title$, row%, col%, w%, showitems%, nor%, list$(), slct%)
  DECLARE SUB PlaceCursor (row%, showitems%, col%, w%, current%, nor%)

  ' load some values into an array
    nor% = 100
    REDIM list$(nor%)
    FOR i% = 1 TO 100
        list$(i%) = STR$(i%)
    NEXT

  ' create a title screen
    CLS
    PRINT "SCROLLMENU FOR QBASIC"
    PRINT "use arrow keys or page up/down keys to move cursor"
    PRINT "press enter to select or escape to abort"
   
  ' set some parameters and call the scrollmenu procedure
    title$ = "SCROLLMENU SAMPLE"      'title of the menu
    row% = 5                          'top row of menu
    col% = 10                         'upper left column
    w% = 20                           'width of menu window
    IF nor% > 10 THEN
        showitems% = 10               'decide how many items to
    ELSE                              'show at one time
        showitems% = nor%
    END IF
    CALL ScrollMenu(title$, row%, col%, w%, showitems%, nor%, list$(), slct%)

  ' show which selection
    LOCATE 10, 50
    COLOR 15, 0
    IF slct% = 0 THEN
        PRINT "nothing selected"
    ELSE
        PRINT "you selected "; list$(slct%)
    END IF
    COLOR 7, 0

END

SUB PlaceCursor (row%, showitems%, col%, w%, current%, nor%)
      COLOR 14, 0
      LOCATE row% + showitems% + 3, col% + 1
      PRINT STRING$(w%, 176)
      place% = (current% / nor%) * w%
      IF col% + 1 + place% > col% + w% THEN place% = place% - 1
      LOCATE row% + showitems% + 3, col% + 1 + place%
      PRINT CHR$(219)
END SUB

SUB ScrollMenu (title$, row%, col%, w%, showitems%, nor%, list$(), slct%)
DEFINT A-Z

' draw menu
  IF nor% > 10 THEN showitems% = 10 ELSE showitems% = nor%
  current% = 1
  start% = 1
  EndList% = start% + showitems% - 1

  ' first draw the box
    COLOR 9, 0
    LOCATE row%, col% + 2
    PRINT title$
    LOCATE 1 - start% + 1 + row%, col%
    PRINT ""; STRING$(w%, 196); ""
    FOR s% = 1 TO showitems%
        LOCATE s% - start% + 2 + row%, col%
        PRINT ""; SPACE$(w%); ""
    NEXT
    LOCATE row% + showitems% + 2, col%
    PRINT ""; STRING$(w%, 196); ""

  DO
    ' draw place cursor
      CALL PlaceCursor(row%, showitems%, col%, w%, current%, nor%)

      LOCATE row% + 1, col% + 1
      FOR i% = start% TO EndList%

        LOCATE i% - start% + 2 + row%, col% + 1
      
        SELECT CASE current%
            CASE i%
                COLOR 0, 3
            CASE ELSE
                COLOR 7, 0
        END SELECT

        PRINT LEFT$(list$(i%) + SPACE$(w%), w%);

      NEXT

      DO
        a$ = INKEY$
      LOOP WHILE a$ = ""

    SELECT CASE UCASE$(a$)
        CASE CHR$(27) 'escape
            slct% = 0
            EXIT DO
        CASE CHR$(0) + "P"  'down arrow
            current% = current% + 1
            IF current% > showitems% AND current% > EndList% THEN start% = start% + 1
            IF current% > nor% THEN current% = nor%
            EndList% = start% + showitems% - 1
            IF EndList% > nor% THEN
                EndList% = nor%
                start% = EndList% - showitems% + 1
            END IF
        CASE CHR$(0) + "H"  'up arrow
            current% = current% - 1
            IF current% < 1 THEN current% = 1
            IF current% < start% THEN start% = start% - 1
            EndList% = start% + showitems% - 1
        CASE CHR$(13) 'enter
            slct% = current%
            EXIT DO
        CASE CHR$(0) + "Q" 'page down
            current% = current% + showitems%
            IF current% > nor% THEN current% = nor%
            IF current% > EndList% THEN start% = start% + showitems%
            IF start% > nor% THEN start% = nor% - showitems%
            EndList% = start% + showitems% - 1
            IF EndList% > nor% THEN
                EndList% = nor%
                start% = EndList% - showitems% + 1
            END IF
        CASE CHR$(0) + "I" 'page up
            current% = current% - showitems%
            IF current% < 1 THEN current% = 1
            IF current% < start% THEN start% = start% - showitems%
            IF start% < 1 THEN start% = 1
            EndList% = start% + showitems% - 1
    END SELECT

  LOOP

  COLOR 7, 0

END SUB

